<?php  defined('C5_EXECUTE') or die("Access Denied.");
use Concrete\Core\View\View;
use Concrete\Core\Support\Facade\Application;
// handle (required, unique)
// name (possibly unique, defaults to uncamelcase handle)
// description
// thumbnail
// getThemeDisplayName()
$app = Application::getFacadeApplication();
$al = $app->make('helper/concrete/asset_library');
$valt = $app->make('helper/validation/token');

View::element('styles', [], $kalmoya->pkgHandle);
View::element('kalmoya_dashboard_header', ['kalmoya' => $kalmoya, 'app' => $app], $kalmoya->pkgHandle);

if (isset($errors)) {
    ?>
    <div class="alert alert-danger">
        <a data-dismiss="alert" href="#" class="close">&times;</a>
        <?php  echo $errors; ?>
    </div>
    <?php
} ?>
<?php
    echo $app->make('helper/concrete/ui')->tabs(
        [
            ['kal-settings', t('Theme Settings'), true],
            ['kal-package', t('Package Settings')],
            ['kal-support', t('Support')],
        ]
    );
?>

<form id="elemental-cloner" method="post" action="<?php echo $view->action('run'); ?>">
    <div class="tab-content">
        <div id="kal-settings" class="tab-pane show active" role="tabpanel">
            <?php echo $valt->output('create_core_theme_clone'); ?>
            <?php echo $form->hidden('themeToClone', 'elemental'); ?>
            <div class="row">
                <div class="col-sm-6">
                    <div class="form-group">
                        <?php echo $form->label('themeHandle', t("Theme's handle")); ?>
                        <?php echo $form->text('themeHandle', null); ?>
                        <small class="center-block text-danger">
                            <?php echo t("%s A valid and unique handle is required", '<i class="fas fa-star"></i>'); ?>
                        </small>
                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="form-group">
                        <?php echo $form->label('themeName', t("Theme's name")); ?>
                        <?php echo $form->text('themeName', null); ?>
                        <div class="help-block mt-0 small"><?php echo t("If left empty it will be inferred from the handle"); ?></div>
                    </div>
                </div>
                <div class="col-sm-12">
                    <div class="form-group">
                        <?php echo $form->label('themeDescription', t("Theme's description")); ?>
                        <?php echo $form->text('themeDescription', null); ?>
                        <div class="help-block mt-0 small"><?php echo t("If left empty, the cloned theme's original description will be used"); ?></div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <?php echo $form->label('googleFonts', t("Load the theme's font files")); ?>
                        <?php echo $form->select('googleFonts', ['google' => t("From's Google CDN (default)"), 'local' => t("From your server (good for GDPR)")], null); ?>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <?php echo $form->label('thumbSource', t("Get the theme's thumbnail")); ?>
                        <?php echo $form->select('thumbSource', ['none' => t("From the cloned theme's own thumbnail"), 'upload' => t("From my computer"), 'manager' => t("From the file manager")], null); ?>
                        <div class="help-block mt-0 small thumbSource"><?php echo t("Your image will be resized to %s", '360 x 270 pixels'); ?></div>
                    </div>
                </div>
            </div>
            <div class="row form-group box-wrapper thumb-uploader" style="display:none;">
                <div class="col-sm-12">
                    <div class="fileinput-box themeThumb">
                        <span class="drop-box-msg"><?php echo t("Drop a PNG or JPG image file here or click to upload"); ?></span>
                        <?php echo $form->label('themeThumb', t("Select your theme's thumbnail from your computer"), ['class' => 'sr-only']); ?>
                        <input type="file" id="themeThumb" name="themeThumb" accept=".jpg,.jpeg,.png">
                        <input type="hidden" id="uploaded-filename" name="filename" value="<?php echo isset($filename) ? $filename : null; ?>">
                        <div id="progress-wrapper" class="cloner-process-progress">
                            <div id="progress" class="progress cloner-progress progress-striped active" role="progressbar" aria-valuemin="0" aria-valuemax="100" aria-valuenow="0"><div class="progress-bar progress-bar-warning" style="width:0%;"></div></div>
                        </div>
                        <div id="upload-message" class="files"></div>
                    </div>
                </div>
            </div>
            <div class="row thumb-manager" style="display:none;">
                <div class="col-sm-12">
                    <div class="form-group">
                        <?php echo $form->label('fID', t("Select your theme's thumbnail from the file manager"), ['class' => 'sr-only']); ?>
                        <?php
                        echo $al->image(
                            'manager-filename',
                            'fID',
                            t('Choose a thumbnail image'),
                            null,
                            [
                                'filters' =>
                                [
                                    [
                                        'field' => 'extension',
                                        'extension' => ['png', 'jpg', 'jpeg'],
                                    ],
                                ]
                            ]
                        ); ?>
                    </div>
                </div>
            </div>
        </div>

        <div id="kal-package" class="tab-pane" role="tabpanel">
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <?php echo $form->label('buildPackage', t("Would you like to package your theme?")); ?>
                        <?php echo $form->select('buildPackage', [0 => t("No, put it in my %s", '&ldquo;application/themes directory&rdquo;'), 1 => t("Yes, package my theme")], null); ?>
                    </div>
                </div>
            </div>
            <div class="package-data clearfix">
                <div class="row">
                    <div class="col-sm-6">
                        <div class="form-group">
                            <?php echo $form->label('pkgHandle', t("Package's handle")); ?>
                            <?php echo $form->text('pkgHandle', null); ?>
                            <small class="center-block text-danger">
                                <?php echo t("%s A valid and unique handle is required", '<i class="fas fa-star"></i>'); ?>
                            </small>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            <?php echo $form->label('pkgName', t("Package's name")); ?>
                            <?php echo $form->text('pkgName', null); ?>
                            <div class="help-block mt-0 small"><?php echo t("If left empty it will be inferred from the handle"); ?></div>
                        </div>
                    </div>
                    <div class="col-sm-12">
                        <div class="form-group">
                            <?php echo $form->label('pkgDescription', t("Package's description")); ?>
                            <?php echo $form->text('pkgDescription', null); ?>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="form-group">
                            <?php echo $form->label('pkgVersion', t("Package's version number")); ?>
                            <?php echo $form->text('pkgVersion', null); ?>
                            <div class="help-block mt-0 small"><?php echo t("If left empty it will be %s", '&ldquo;0.9&rdquo;'); ?></div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            <?php echo $form->label('pkgAppVersion', t("Minimum Concrete5 version required")); ?>
                            <?php echo $form->text('pkgAppVersion', null); ?>
                            <div class="help-block mt-0 small"><?php echo t("If left empty it will be %s", '&ldquo;9.0&rdquo;'); ?></div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        <div class="form-group">
                            <?php echo $form->label('pkgThumbSource', t("Get the package's icon")); ?>
                            <?php echo $form->select('pkgThumbSource', ['none' => t("From Concrete5 default package icon"), 'upload' => t("From my computer"), 'manager' => t("From the file manager")], null); ?>
                            <div class="help-block mt-0 small pkgThumbSource"><?php echo t("Your image will be resized to %s", '97 x 97 pixels'); ?></div>
                        </div>
                    </div>
                </div>
                <div class="row form-group box-wrapper pkg-thumb-uploader" style="display:none;">
                    <div class="col-sm-12">
                        <div class="fileinput-box pkgThumb">
                            <span class="drop-box-msg"><?php echo t("Drop a PNG or JPG image file here or click to upload"); ?></span>
                            <?php echo $form->label('pkgThumb', t("Select your package's icon from your computer"), ['class' => 'sr-only']); ?>

                            <input type="file" id="pkgThumb" name="pkgThumb" accept=".jpg,.jpeg,.png">
                            <input type="hidden" id="pkg-uploaded-filename" name="pkgIcon" value="<?php echo isset($pkgIcon) ? $pkgIcon : null; ?>">
                            <div id="pkg-progress-wrapper" class="cloner-process-progress">
                                <div id="pkg-progress" class="progress cloner-progress progress-striped active" role="progressbar" aria-valuemin="0" aria-valuemax="100" aria-valuenow="0"><div class="progress-bar progress-bar-warning" style="width:0%;"></div></div>
                            </div>
                            <div id="pkg-upload-message" class="files"></div>
                        </div>
                    </div>
                </div>
                <div class="row pkg-thumb-manager" style="display:none;">
                    <div class="col-sm-12">
                        <div class="form-group">
                            <?php echo $form->label('pkgfID', t("Select your package's icon from the file manager"), ['class' => 'sr-only']); ?>
                            <?php
                            echo $al->image(
                                'pkg-manager-filename',
                                'pkgfID',
                                t('Choose a thumbnail image'),
                                null,
                                [
                                    'filters' =>
                                    [
                                        [
                                            'field' => 'extension',
                                            'extension' => ['png', 'jpg', 'jpeg'],
                                        ],
                                    ]
                                ]
                            ); ?>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <?php
        View::element('kalmoya_support_tab', ['kalmoya' => $kalmoya], $kalmoya->pkgHandle);
        ?>
        <div class="ccm-dashboard-form-actions-wrapper">
            <div class="ccm-dashboard-form-actions">
                <button id="clone-theme" class="clone-theme float-end btn btn-success" type="submit" ><i class="fas fa-wrench" aria-hidden="true"></i>&nbsp;<?php echo t('Build your theme'); ?></button>
            </div>
        </div>
    </div> <!-- .tab-content -->
</form>

<script>
    $(function () {
        'use strict';
        // managing thumbnail import
        // Change this to the location of your server-side upload handler:
        var setupImageUploader = function(input, prefix) {
            prefix = prefix || '';
            var filename = $('#' + prefix + 'uploaded-filename');
            var messagebox = '#' + prefix + 'upload-message';
            var progressbar = $('#' + prefix + 'progress');
            var dropzone = $('.fileinput-box.' + input);
            <?php
            // TODO: do proper URL stuff
            ?>
            var url = '<?php echo View::url("/elementalcloner/uploadThumb/uploadinput"); ?>';
            url = url.replace('uploadinput', input);
            $('#' + input).fileupload({
                url: url,
                dropZone: dropzone,
                dataType: 'json',
                error: function(r) {
                    filename.val(null);
                    $(messagebox).removeClass('alert-success').addClass('alert alert-danger showing');
                    progressbar.find('.progress-bar').css(
                        'width',
                        '0%'
                    );
                    var message = r.responseText;

                    try {
                        message = jQuery.parseJSON(message).errors;
                        $(messagebox).empty();
                        _(message).each(function(error) {
                            $('<p/>').html(error).appendTo(messagebox);
                        });
                    } catch (e) {
                        message = message.split('<br />');
                        $(messagebox).html(message[message.length - 1]);
                    }
                },
                done: function (e, data) {
                    $(messagebox).removeClass('alert-danger').addClass('alert alert-success showing');
                    if (data.result.file && data.result.file.length) {
                        $(messagebox).empty();
                        $.each(data.result.file, function (index, file) {
                            filename.val(file.name);
                            $('<img width="90" src="' + URL.createObjectURL(data.files[0]) + '"/>').appendTo(messagebox);
                            $('<p/>').html(file.name + " <?php echo t('uploaded successfully'); ?>").appendTo(messagebox);
                        });
                    }

                    progressbar.find('.progress-bar').css(
                        'width',
                        '100%'
                    );

                },
                progressall: function (e, data) {
                    var progress = parseInt(data.loaded * 0.85 / data.total * 100, 10);
                    progressbar.find('.progress-bar').css(
                        'width',
                        progress + '%'
                    );
                },
                always: function (e, data) {
                    $('.ccm-dashboard-form-actions #clone-theme').prop('disabled', false);
                },
                change: function() {
                    progressbar.find('.progress-bar').css(
                        'width',
                        '0%'
                    );
                    $(messagebox).removeClass('showing').empty();

                },
                start: function() {
                    progressbar.find('.progress-bar').css(
                        'width',
                        '0%'
                    );
                    $(messagebox).removeClass('showing').empty();
                    $('.ccm-dashboard-form-actions #clone-theme').prop('disabled', true);
                }
            }).prop('disabled', !$.support.fileInput)
                .parent().addClass($.support.fileInput ? undefined : 'disabled');

            $('#' + input).bind('fileuploadsubmit', function (e, data) {
            data.formData = {
                ccm_token: '<?php echo $app->make("token")->generate("upload_theme_and_pkg_thumb"); ?>',
            }
        });
        }

        // setting up file uploaders
        setupImageUploader('themeThumb');
        setupImageUploader('pkgThumb', 'pkg-');

        // managing theme cloning
        var elementalCloner = {
            generating: false,
            button: null,
            alert: null,
            operationStatusLabel: "",
            triggerProgressiveOperation: function(url, params, onComplete, onError) {
                elementalCloner.button.prop("disabled", true);
                NProgress.set(0);
                elementalCloner.generating = true;
                $.ajax({
                    url: url,
                    type: 'POST',
                    data: params,
                    dataType: 'html',
                    timeout: 60000,
                    beforeSend: function(jqXHR, ajaxSettings) {
                        var dialogTitle = "<?php echo t("Cloning%s", ' {{clonedTheme}}...'); ?>";
                        var themeToClone = params.themeToClone;
                        themeToClone = themeToClone.charAt(0).toUpperCase() + themeToClone.slice(1);

                        dialogTitle = dialogTitle.replace('{{clonedTheme}}', themeToClone);

                        var buildPackage = (params.buildPackage == '1');
                        if (buildPackage) {
                            dialogTitle = "<?php echo t("Building a package%s", '...'); ?>";
                        }

                        elementalCloner.alert = ConcreteAlert.info({
                            message: "<?php echo t("Gathering information"); ?>",
                            title: dialogTitle,
                            hide: false,
                            width: '450px',
                            closer: false,
                            icon: 'spinner fa-spin'
                        });
                    }
                }).done(function(r, textStatus, jqXHR) {
                    if (r && typeof r === "string") {
                            r = JSON.parse(r);
                        }

                        if (r.error) {
                            var text = '<div class="alert alert-danger">' + r.errors.toString() + '</div>';

                            NProgress.remove();
                            elementalCloner.button.prop("disabled", false);
                            elementalCloner.generating = false;

                            ConcreteAlert.error({'title': ccmi18n.error, 'message': text, 'delay': 4000});

                            if (typeof(onError) == 'function') {
                                onError(r);
                            }
                        } else {
                            var themeToClone = params.themeToClone;
                            themeToClone = themeToClone.charAt(0).toUpperCase() + themeToClone.slice(1);
                            params.action = r.action;
                            params.actionNbr = r.actionNbr;
                            params.totalActions = r.totalActions;

                            elementalCloner.doProgressiveOperation(url, params, onComplete, onError, themeToClone);
                        }
                        elementalCloner.generating = false;
                    }).fail(function(xhr, status, r) {
                        elementalCloner.button.prop("disabled", false);
                        elementalCloner.generating = false;
                        switch (status) {
                            case 'timeout':
                                var text = ccmi18n.requestTimeout;
                                break;
                            default:
                                var text = ConcreteAjaxRequest.errorResponseToString(xhr);
                                break;
                        }
                        NProgress.remove();
                        elementalCloner.alert.close();
                        ConcreteAlert.error({'title': ccmi18n.error, 'message': text, 'delay': 4000});

                        if (typeof(onError) == 'function') {
                            onError(r);
                        }
                    });
            },

            doProgressiveOperation: function(url, params, onComplete, onError, themeToClone) {
                params.process = true;

                $.ajax({
                    url: url,
                    dataType: 'json',
                    type: 'POST',
                    data: params,
                    timeout: 60000,
                }).done(function(r, textStatus, jqXHR) {
                        if (r && typeof r === "string") {
                            r = JSON.parse(r);
                        }

                        if (r.error) {
                            elementalCloner.alert.close();
                            NProgress.remove();
                            ConcreteAlert.error({'title': ccmi18n.error, 'message': r.errors.toString(), 'delay': 4000});

                            if (typeof(onError) == 'function') {
                                onError(r);
                            }
                        } else {
                            // update the percentage
                            if (r.action && r.actionNbr <= params.totalActions) {
                                var operationStatusLabel;
                                switch (r.action) {
                                    case 'clone':
                                        operationStatusLabel = "<?php echo t("Cloning%s", '&nbsp;{{clonedTheme}}&hellip;'); ?>";
                                        operationStatusLabel = operationStatusLabel.replace('{{clonedTheme}}', themeToClone);
                                        break;
                                    case 'customize':
                                        operationStatusLabel = "<?php echo t("Customizing your theme's information%s", '&hellip;'); ?>";
                                        break;
                                    case 'googleFonts':
                                        operationStatusLabel = "<?php echo t("Switching Google Fonts to local%s", '&hellip;'); ?>";
                                        break;
                                    case 'thumb':
                                        operationStatusLabel = "<?php echo t("Generating the theme's thumbnail%s", '&hellip;'); ?>";
                                        break;
                                    default:
                                        break;
                                }

                                elementalCloner.alert.update({
                                        text: operationStatusLabel,
                                    });
                            }

                            if (r.actionNbr <= params.totalActions) {
                                var pct = (r.actionNbr - 1) / params.totalActions;
                                NProgress.set(pct);

                                params.action = r.action;

                                setTimeout(function() {
                                    elementalCloner.doProgressiveOperation(url, params, onComplete, onError, themeToClone);
                                }, 250);
                            } else {
                                NProgress.set(1);
                                setTimeout(function() {
                                    // give the animation time to catch up.
                                    NProgress.done();
                                    elementalCloner.alert.close();

                                    ConcreteAlert.notify({
                                        message: r.successMessage,
                                        title: r.successTitle,
                                        width: '450px',
                                        buttons: {
                                            closer: false
                                        }
                                    });

                                    if (typeof(onComplete) == 'function') {
                                        onComplete(r.callbackparameter);
                                    }
                                }, 1000);
                            }
                        }
                    }).always(function(){
                        elementalCloner.button.prop("disabled", false);
                        elementalCloner.generating = false;

                    }).fail(function(xhr, status, r) {
                        var text;

                        switch (status) {
                            case 'timeout':
                                text = ccmi18n.requestTimeout;
                                break;
                            default:
                                text = ConcreteAjaxRequest.errorResponseToString(xhr);
                                break;
                        }
                        // pnotify.remove();
                        NProgress.remove();
                        elementalCloner.alert.close();
                        ConcreteAlert.error({'title': ccmi18n.error, 'message': text, 'delay': 4000});

                        if (typeof(onError) == 'function') {
                            onError(r);
                        }
                    });
            }
        }
        var scrollToBottom = function() {
            $('html,body').animate({scrollTop: document.body.scrollHeight}, 350);
        }

        $('#thumbSource').on('change', function(evt) {
            if ($(this).val() == 'upload') {
                $('.thumb-uploader').slideDown(350, scrollToBottom);
                $('.thumb-manager').slideUp();
                $('.help-block.thumbSource').fadeIn();
            } else if ($(this).val() == 'manager') {
                $('.thumb-uploader').slideUp();
                $('.thumb-manager').slideDown(350, scrollToBottom);
                $('.help-block.thumbSource').fadeIn();
            } else {
                $('.thumb-uploader').slideUp();
                $('.thumb-manager').slideUp();
                $('.help-block.thumbSource').fadeOut();
            }
        });
        $('#thumbSource').trigger('change');

        $('#pkgThumbSource').on('change', function(evt) {
            if ($(this).val() == 'upload') {
                $('.pkg-thumb-uploader').slideDown(350, scrollToBottom);
                $('.pkg-thumb-manager').slideUp();
                $('.help-block.pkgThumbSource').fadeIn();
            } else if ($(this).val() == 'manager') {
                $('.pkg-thumb-uploader').slideUp();
                $('.pkg-thumb-manager').slideDown(350, scrollToBottom);
                $('.help-block.pkgThumbSource').fadeIn();
            } else {
                $('.pkg-thumb-uploader').slideUp();
                $('.pkg-thumb-manager').slideUp();
                $('.help-block.pkgThumbSource').fadeOut();
            }
        });
        $('#pkgThumbSource').trigger('change');

        $('#buildPackage').on('change', function(evt) {
            if ($(this).val() == '1') {
                $('.package-data').slideDown();
            } else {
                $('.package-data').slideUp();
            }
        });


        $(document).ready(function() {
            var themeFileSelector = $('.thumb-manager').find('[data-file-selector="manager-filename"]'),
                themeFileSelectorTemplate = themeFileSelector.html(),
                pkgFileSelector = $('.pkg-thumb-manager').find('[data-file-selector="pkg-manager-filename"]'),
                pkgFileSelectorTemplate = pkgFileSelector.html();

            var resetCloner = function() {
                $("#elemental-cloner").get(0).reset();
                $('#uploaded-filename').val(null);
                $('#pkg-uploaded-filename').val(null);
                $('input[type=hidden][name=fID]').val(0);
                $('input[type=hidden][name=pkgfID]').val(0);
                themeFileSelector.html(themeFileSelectorTemplate);
                pkgFileSelector.html(pkgFileSelectorTemplate);

                $('#progress .progress-bar').css(
                    'width',
                    '0%'
                );
                $('#pkg-progress .progress-bar').css(
                    'width',
                    '0%'
                );

                $('#upload-message').removeClass('showing').empty();
                $('#pkg-upload-message').removeClass('showing').empty();

                $('a#kal-settings-tab').trigger('click');
                $('#thumbSource').trigger('change');
                $('#pkgThumbSource').trigger('change');
                $('#buildPackage').trigger('change');
            }

            $('a[data-bs-toggle="tab"]').on ('click', function() {
                var tab = $(this).attr('aria-controls');
                if (tab === 'kal-support') {
                    $('.ccm-dashboard-form-actions-wrapper').hide();
                } else {
                    $('.ccm-dashboard-form-actions-wrapper').fadeIn(350);
                }
            });

            $("#elemental-cloner").on("submit", function(e) {
                e.preventDefault();
                if (!elementalCloner.generating) {
                    elementalCloner.button = $(this).find('button[type="submit"]');
                    var formdata = $(this).serializeArray(),
                    data = {},
                    url = "<?php echo $view->action('run'); ?>";
                    $(formdata).each(function(index, obj){
                        data[obj.name] = obj.value;
                    });

                    elementalCloner.triggerProgressiveOperation(url, data, resetCloner);
                }
            });
        });
    });
</script>
